# This program adds up the entries in the array "val"
# The system call codes are described in Appendix A, p A-48.
# This file was written in the Context editor with smart tabs
# turned off (Options -> Environment -> Editor -> Smart Tabs).

        .data   # The following entries go in the data segment
strA:
        .asciiz "\nThe number of entries in the value array is "
strB:
        .asciiz "\nTheir sum is "
val:
        .word   1,3,5,7,9,11,13,15
endtag:                         # must be the address after the array

        .text   # The following entries go in the text (program code) segment
main:
        la      $a0,strA        # load address of the string to print
        li      $v0,4           # load print_string code
        syscall                 # ask the system to print the string
        
        # calculate and print the length of the array

        la      $t0,val         # load the address of the first word of the array
        la      $t1,endtag      # load the address of the word following the array
        sub     $t2,$t1,$t0     # calculate the length of the array in bytes
        srl     $t2,$t2,2       # shift right by 2, ie, divide by 4 to get word count

        li      $v0,1           # load print_integer code
        move    $a0,$t2         # put the word count in $a0 for printing
        syscall                 # ask the system to print the integer
        
        # calculate and print the sum of the elements in the array

        move    $t0,$zero       # $t0 = sum = 0
        la      $t1,val         # $t1 = next = address(val)
        la      $t2,endtag      # $t2 = endtag = address(endtag)
        beq     $t1,$t2,skip    # if array length is zero then done
loop:
        lw      $t3,0($t1)      # $t3 = next array value
        add     $t0,$t0,$t3     # $t0 = $t0 + $t3
        addi    $t1,4           # point to next word in array
        bne     $t1,$t2,loop    # loop if more data in array

skip:
        la      $a0,strB        # load address of the string to print
        li      $v0,4           # load print_string code
        syscall                 # ask the system to print the string

        li      $v0,1           # load print_integer code
        move    $a0,$t0         # put the sum in $a0 for printing
        syscall                 # ask the system to print the integer

        jr      $ra             # return

